//聊天框处理方法：
(function(window) {
    //输入框控件：
    var UIChatBox;
    //对外处理对象
    var chat_box = {};
    //消息发送类型：
    var msg_type = {
        text: 'text', //文本
        share: 'share', //分享
        picture: 'picture', //图片
        video: 'video', //视频
        voice: 'voice' //语音
    };
    //定义发送的人的变量
    var send = {
        action_type: '',
        sender_type: '',
        sender_user_id: '',
        parttime_id: 0
    }
    var cancel_imgs = ["cancel1.png", "cancel2.png", "cancel3.png", "cancel4.png"]; // 图片地址
    var counter = 0;
    //初始化：
    chat_box.init = function(params, cb) {
        send.action_type = params.action_type;
        send.sender_type = params.sender_type;
        send.sender_user_id = params.sender_user_id;
        send.parttime_id = params.parttime_id;
        //初始化控件：
        UIChatBox = api.require('UIChatBox');
        chat_box.cb = cb;
        //打开输入框：
        openChatBox();
    }

    //附加功能面板点击处理方法：
    var clickExtras = [
        function() { //图片选择
            hasAndReqPermission('camera', '相册', function () {
                api.getPicture({
                    sourceType: 'library',
                    encodingType: 'jpg',
                    mediaValue: 'pic',
                    destinationType: 'url',
                    quality: 80,
                    saveToPhotoAlbum: false
                }, function(ret, err) {
                    if (ret) {
                        if (ret.data) {
                            //发送传递方法
                            var data = {};
                            data.type = msg_type.picture;
                            data.files = ret.data;
                            sendMessageEvent(data);
                        }
                    }
                });
            });

        },
        function() { //相机拍照
            hasAndReqPermission('camera', '拍照', function () {
                api.getPicture({
                    sourceType: 'camera',
                    encodingType: 'jpg',
                    mediaValue: 'pic',
                    destinationType: 'url',
                    quality: 80,
                    saveToPhotoAlbum: true
                }, function(ret, err) {
                    if (ret) {
                        if (ret.data) {
                            //发送传递方法
                            var data = {};
                            data.type = msg_type.picture;
                            data.files = ret.data;
                            sendMessageEvent(data);
                        }
                    }
                });
            });
        }
    ];


    //打开输入框：
    function openChatBox() {
        UIChatBox.open({
            placeholder: '',
            maxRows: 4,
            emotionPath: 'widget://image/emotion',
            texts: {
                recordBtn: { //（可选项）JSON对象；录音按钮文字内容
                    normalTitle: '按住 说话', //（可选项）字符串类型；按钮常态的标题，默认：'按住 说话'
                    activeTitle: '松开 结束' //（可选项）字符串类型；按钮按下时的标题，默认：'松开 结束'
                },
                sendBtn: { //（可选项）JSON对象；发送按钮文字内容，在 iOS 平台上对键盘内按钮无效
                    title: '发送' //（可选项）字符串类型；按钮常态的标题，默认：'发送'
                }
            },
            styles: {
                inputBar: {
                    borderColor: '#d9d9d9',
                    bgColor: '#FFFFFF'
                },
                inputBox: {
                    borderColor: '#B3B3B3',
                    bgColor: '#FFFFFF',
                    boardBgColor: '#FFFFFF'
                },
                emotionBtn: {
                    normalImg: 'widget://image/chatBox/emotion.png'
                },
                extrasBtn: {
                    normalImg: 'widget://image/chatBox/menu.png'
                },
                keyboardBtn: {
                    normalImg: 'widget://image/chatBox/keyword.png'
                },
                speechBtn: { //（可选项）JSON对象；输入框左侧按钮样式，不传则不显示左边的语音按钮
                    normalImg: 'widget://image/chatBox/send_voice.png' //字符串类型；左侧按钮常态的背景图片（本地路径，fs://、widget://）
                },
                recordBtn: { //JSON对象；“按住 录音”按钮的样式
                    normalBg: '#e5e5e5', //（可选项）字符串类型；按钮常态的背景，支持 rgb，rgba，#，图片路径（本地路径，fs://、widget://）；默认：'#c4c4c4'
                    activeBg: '#c4c4c4', //（可选项）字符串类型；按钮按下时的背景，支持 rgb，rgba，#，图片路径（本地路径，fs://、widget://）；默认：'#999999'；normalBg 和 activeBg 必须保持一致，同为颜色值，或同为图片路径
                    color: '#000', //（可选项）字符串类型；按钮标题文字的颜色，支持 rgb，rgba，#，默认：'#000000'
                    size: 14 //（可选项）数字类型；按钮标题文字的大小，默认：14
                },
                indicator: {
                    target: 'both',
                    color: '#c4c4c4',
                    activeColor: '#9e9e9e'
                }
            },
            extras: {
                titleSize: 12,
                titleColor: '#666',
                btns: [{
                    title: '图片',
                    normalImg: 'widget://image/chatBox/picture.png'
                }, {
                    title: '拍照',
                    normalImg: 'widget://image/chatBox/photo.png'
                }]
            }
        }, function(ret) {
            //录音监听打开
            setUpListener();
            if (ret.eventType == 'clickExtras') { //点击附加功能面板
                clickExtras[ret.index] && clickExtras[ret.index]();
            } else if (ret.eventType == 'send' && ret.msg) { //点击发送按钮
                //发送传递方法
                var data = {};
                data.type = msg_type.text;
                data.content = ret.msg;
                sendMessageEvent(data);
            }
        });
    }
    //消息发送处理方法：
    function sendMessageEvent(data) {
        var post = {};
        post.values = {
            msg_content: data.content ? data.content : '',
            receiver_type: send.sender_type,
            receiver_user_id: send.sender_user_id,
            type: data.type ? data.type : 'text',
            time: data.time ? data.time : 0,
            parttime_id: send.parttime_id ? send.parttime_id : 0
        };
        if (data.files) {
            post.files = {
                'file': data.files
            };
        }

        //调用网络请求方法
        networkRequest('/station_msg/send_station', function(ret) {
            if (ret.status == cfg.status.success) {
                api.sendEvent({
                    name: 'addSendMsg'
                });
            }
        }, post);
    }
    //录音的监听事件方法
    function setUpListener() {
        //监听按下录音
        UIChatBox.addEventListener({
            target: 'recordBtn',
            name: 'press'
        }, function(ret, err) {
            if (ret) {
                $api.css($api.byId('cancel'), 'display:block;');
                cancel_send_show();

                hasAndReqPermission('microphone', '麦克风', function () {
                    api.startRecord({});
                });
            } else {
                alert(JSON.stringify(err));
            }
        });
        //监听松开录音键
        UIChatBox.addEventListener({
            target: 'recordBtn',
            name: 'press_cancel'
        }, function(res, error) {
            $api.css($api.byId('cancel'), 'display:none;');
            cancel_send_hide();
            //松开后停止录音
            api.stopRecord(
                function(ret, err) {
                    if (ret) {
                        if (ret.duration >= 1) {
                            //发送传递方法
                            var data = {};
                            data.type = msg_type.voice;
                            data.files = ret.path;
                            data.time = ret.duration;
                            sendMessageEvent(data);
                        } else {
                            form_tip('录音时间太短，无法发送');
                        }
                    }
                }
            );
        });
        //移除录音
        UIChatBox.addEventListener({
            target: 'recordBtn',
            name: 'move_out'
        }, function(res, error) {
            cancel_send_hide();
            $api.css($api.byId('cancel_conf'), 'display:block;');
        });
        //移除录音取消
        UIChatBox.addEventListener({
            target: 'recordBtn',
            name: 'move_out_cancel'
        }, function(res, error) {
            $api.css($api.byId('cancel_conf'), 'display:none;');
            $api.css($api.byId('cancel'), 'display:none;');
            cancel_send_hide();
            api.stopRecord();
        });
        //移除录音后再移入
        UIChatBox.addEventListener({
            target: 'recordBtn',
            name: 'move_in'
        }, function(res, error) {
            $api.css($api.byId('cancel_conf'), 'display:none;');
            cancel_send_show();
        });
    }
    //录音展现图
    function cancel_send_show() {
        $api.css($api.byId('cancel_send'), 'display:block;');
        cancel_send = setInterval(function() {
            counter++;
            if (counter == cancel_imgs.length)
                counter = 0;
            $api.attr($api.byId('cancel_send'), 'src', '../../image/chatBox/' + cancel_imgs[counter]);
        }, 250);
    }
    //上划取消图
    function cancel_send_hide() {
        $api.css($api.byId('cancel_send'), 'display:none;');
        clearInterval(cancel_send);
    }
    window.chat_box = chat_box;
})(window);
