// 蚂蚁兼职主要JS
//相关配置信息：
var cfg = {
    app_name: '蚂蚁兼职', //APP名称
    main_url: 'www.school51.com', //网站地址
    api_url: 'http://napi.school51.com', //接口访问地址
    h5_url: 'http://h5.school51.com', //H5页面地址
    nwap_url: 'http://nwap.school51.com',
    //==========缓存相关KEY==========
    cache_type: {
        app_version: 'app_version',
        last_app_version: 'last_app_version',
        app_type: 'app_type',
        city_name: 'city_name',
        city_code: 'city_code',
        sid: 'sid',
        login_mobile: 'login_mobile',
        location_lat: 'location_lat',
        location_lng: 'location_lng',
        first_open: 'is_first_open',

        fromuid: 'fromuid',
        fromuid_time: 'fromuid_time'
    },
    //==========接口状态码===========
    status: {
        error: 0, ///** 出错 */
        success: 1, ///** 成功 */
        custom: 2, ///** 非成功性质的自定义提示状态 */====未使用====
        no_records: 3, ///** 没有找到数据记录 */
        no_more: 4, ///** 没有更多数据 */

        login: 11, ///** 需要登录，未登录 */
        expired: 12, ///** sid过期，需要重新登录（sid值不对） */
        imperfect: 13, ///** 资料不完善 */
        termination: 14, ///** 账户已终止 */====未使用====
        verify: 15, ///** 需要实名认证 */====未使用====
        not_custom: 16, ///** 没有定制相关数据 */====未使用====

        register_continue: 20, ///** 注册未成功，需要跳转到相应步骤继续处理的 */
        show_web: 30, ///** 显示WEB弹窗界面(直接跳转到WEB页面) */
        show_web_alert: 31, ///** 显示WEB弹窗界面(会提示信息，如果点击确定才跳转) */
        show_pay: 35, ///** 显示支付处理 */
        show_pay_alert: 36, ///** 提示并显示支付处理 */

        close_error: 41, ///** 弹出错误提示并关闭界面 */
        close_toast: 42, ///** 弹出Toast并关闭界面 */
        close_show_web: 43, ///** 显示WEB弹窗界面(直接跳转到WEB页面) 【同时关闭当前界面】*/
        close_show_web_alert: 44, ///** 显示WEB弹窗界面(会提示信息，如果点击确定才跳转) 【同时关闭当前界面】*/

        network_error: 99 //网络出错
    },
    //==========配置信息结束===========
    end: null
};

//初始化方法：每个页面都要放在页面的apiready中执行：
function fnReady() {
    api.parseTapmode();
    //设置状态条样式：
    var headers = $api.domAll('.aui-bar-nav');
    for (var i = 0; i < headers.length; i++) {
        $api.fixStatusBar(headers[i]);
    }

    fnReadyHeader();
    fnReadyKeyback();
    fnReadyOpenWin();

    //更改状态栏颜色：
    api.setStatusBarStyle({
        style: 'light'
    });

    FastClick.attach(document.body);
}

var header, headerHeight = 0;

function fnReadyHeader() {
    header = $api.byId('header');
    if (header) {
        //$api.fixIos7Bar(header);
        headerHeight = $api.offset(header).h;
    }

    var params = api.pageParam
    if (params && params.headerHeight) {
        headerHeight += params.headerHeight;
    }

    //记录分享ID：
    if (params && params.fromuid) {
        set_cache(cfg.cache_type.fromuid, params.fromuid);
        //记录分析ID的时间：
        var timestamp = parseInt(parseInt(Date.parse(new Date()))) / 1000;
        set_cache(cfg.cache_type.fromuid_time, timestamp + '');
    }
};

//返回按钮处理：
function fnReadyKeyback() {
    var keybacks = $api.domAll('.event-back');
    var back_event;
    for (var i = 0; i < keybacks.length; i++) {
        $api.attr(keybacks[i], 'tapmode', 'highlight');
        keybacks[i].onclick = function() {
            back_event = $api.attr(this, 'data');
            if (back_event) {
                api.sendEvent({
                    name: back_event
                });
            } else {
                api.closeWin();
            }
        };
    }
    api.parseTapmode();
};

//设置打开新窗口
function fnReadyOpenWin() {
    var buttons = $api.domAll('.open-win');
    for (var i = 0; i < buttons.length; i++) {
        $api.attr(buttons[i], 'tapmode', 'highlight');
        buttons[i].onclick = function() {
            var target = $api.closest(event.target, '.open-win');
            var winName = $api.attr(target, 'win'),
                winTitle = $api.attr(target, 'winTitle'),
                isNeedLogin = $api.attr(target, 'login'),
                param = $api.attr(target, 'param');
            //alert(winName);
            //解析参数：
            if (param) {
                param = parseJSON(param);
            }

            //判断是否需要登录：
            if (isNeedLogin) {
                judgingLogon(function() {
                    openBackPage(winTitle, winName, param);
                }, true, true)
                return false;
            }
            openBackPage(winTitle, winName, param);
            return false;
        };
    }
    api.parseTapmode();
}

//设置浮动头部
function set_float_header(header_dom_id) {
    //监控移动距离：
    var touchFun = function() {
        var top = document.documentElement.scrollTop || document.body.scrollTop;
        //开始显示的高度
        var s_show_top = 0;
        //多少高度完全显示：
        var show_top = 50;

        //判断是否固定工作搜索条：
        if (top > s_show_top) {
            //计算透明度：
            var opacity = 1 - (show_top - s_show_top - top) / 100;
            //显示
            $api.css($api.byId(header_dom_id), 'display:block;opacity:' + opacity);
        } else {
            //隐藏：
            $api.css($api.byId(header_dom_id), 'display:none;');
        }
    };
    // 监听页面滚动
    if (api.systemType == 'ios') {
        //因为苹果的滚动不能实时触发，设置移动时候也监听位置变动
        window.ontouchmove = touchFun;
    }
    window.onscroll = touchFun;
}

//设置缓存数据：
function set_cache(key, val) {
    $api.setStorage(key, val);
}

//读取缓存内容：
function get_cache(key) {
    var cache = $api.getStorage(key);
    if (cache) {
        return cache;
    }
    return '';
}

//处理网络请求URL：
function initUrl(url) {
    //添加接口域名：
    if (url.indexOf('http://') == -1 && url.indexOf('https://') == -1) {
        url = cfg.api_url + url;
    }
    //城市编码：
    var city_code = get_cache(cfg.cache_type.city_code);
    city_code = city_code ? city_code : '340100'; //大连210200
    if (url.indexOf("?") == -1) {
        url = url + "?city_code=" + city_code;
    } else {
        url = url + "&city_code=" + city_code;
    }

    var sid = get_cache(cfg.cache_type.sid);
    if (sid) {
        url = url + "&sid=" + sid;
    }

    //APP类型
    var from_type = api.systemType == 'ios' ? 20 : 10;
    url = url + "&from_type=" + from_type;
    //设备号
    var token = api.deviceId;
    url = url + "&token=" + token;

    //版本号：
    var app_version = parseInt((api.appVersion + '').replace(/\./g, ''));
    if (api.debug) {
        app_version = 205;
    }
    url = url + "&app_version=" + app_version;

    //加入当前时间戳：
    var timestamp = parseInt(parseInt(Date.parse(new Date()))) / 1000;
    url = url + "&timestamp=" + timestamp;

    //判断邀请ID：
    var fromuid = get_cache(cfg.cache_type.fromuid);
    if (fromuid) {
        var fromuid_time = parseInt(get_cache(cfg.cache_type.fromuid_time));
        //一天内的分享才有效：
        if (timestamp - fromuid_time < 86400) {
            url = url + "&fromuid=" + fromuid + "&fromuid_time=" + fromuid_time;
        }
    }

    //加入验证字符串：
    var private_key = 'school51PriVate_Key';
    url = url + "&app_verify=" + md5(private_key + '//' + city_code + '|' + sid + '|' + from_type + '|' + token + '|' + app_version + '|' + timestamp);

    return url;
}

//网络请求方法：
function networkRequest(url, funSuc, data, lodingTip, is_not_common_back) {
    //处理公共参数：
    if (!data) {
        data = {
            values: {}
        };
    } else if (!data.values) {
        data.values = {};
    }

    //调用系统方法：
    if (lodingTip) {
        show_loding();
    }
    var post_url = initUrl(url);
    console.log('=============Start loading data:' + post_url + '==============');
    // console.log('post data:' + JSON.stringify(data));
    // console.log('=============Start data loading:' + post_url + '================');

    $api.post(post_url, data, function(ret) {
        console.log('=============End loading data:' + post_url + '==============');
        console.log('post data:' + JSON.stringify(data));
        console.log('return data:' + JSON.stringify(ret));
        console.log('=============End data loading:' + post_url + '================');

        //关闭加载提示：
        if (lodingTip) {
            hide_loding();
        }
        //清空sid
        if (ret.status == cfg.status.login || ret.status == cfg.status.expired) {
            //清空sid信息（因为是无效的）
            set_cache(cfg.cache_type.sid, '');
        }

        //不调用下面的公共返回：
        if (is_not_common_back) {
            funSuc && funSuc(ret);
            return;
        }

        //根据状态码判断处理：
        switch (ret.status) {
            case cfg.status.error:
                show_alert(ret.info);
                break;
            case cfg.status.success:
                if (ret.data && Array.isArray(ret.data) && ret.data.length < 10 && lodingTip) {
                    show_no_more('没有更多记录了！');
                }
                break;
            case cfg.status.no_more:
                show_no_more(ret.info);
                break;
            case cfg.status.no_records:
                show_no_records(ret.info);
                break;
            case cfg.status.close_error:
                show_alert(ret.info, function() {
                    api.closeWin();
                });
                break;
            case cfg.status.close_toast:
                show_toast(ret.info);
                api.closeWin();
                break;
            case cfg.status.show_web:
                show_toast(ret.info);
                openBackPage(ret.title, ret.url, ret.param);
                break;
            case cfg.status.close_show_web:
                show_toast(ret.info);
                if (!ret.param) {
                    ret.param = {};
                }
                //需要关闭当前窗口
                ret.param['closeName'] = api.winName;
                //打开网页：
                openBackPage(ret.title, ret.url, ret.param);
                break;
            case cfg.status.show_web_alert:
                show_alert(ret.info, function() {
                    //打开网页：
                    openBackPage(ret.title, ret.url, ret.param);
                });
                break;
            case cfg.status.show_pay:
                show_toast(ret.info);
                openAppPay(ret.pay_id, function() {
                    //成功后重新请求接口：
                    networkRequest(url, funSuc, data, lodingTip, is_not_common_back);
                });
                break;
            case cfg.status.show_pay_alert:
                show_alert(ret.info, function() {
                    openAppPay(ret.pay_id, function() {
                        //成功后重新请求接口：
                        networkRequest(url, funSuc, data, lodingTip, is_not_common_back);
                    });
                });
                break;
            case cfg.status.close_show_web_alert:
                show_alert(ret.info, function() {
                    if (!ret.param) {
                        ret.param = {};
                    }
                    //需要关闭当前窗口
                    ret.param['closeName'] = api.winName;
                    //打开网页：
                    openBackPage(ret.title, ret.url, ret.param);
                });
                break;
            case cfg.status.login:
            case cfg.status.expired:
                //提示
                show_toast(ret.info);
                //弹出登录：
                doLogin();
                break;
            case cfg.status.network_error:
                //网络出错
                show_no_more(ret.info);
                break;
        }
        funSuc && funSuc(ret);
    });
}

function doLogin(cb) {
    //添加事件监听
    api.addEventListener({
        name: 'loginBackEvent'
    }, function(ret, err) {
        window.setTimeout(function() {
            cb && cb();
        }, 100);
        //移除事件监听
        api.removeEventListener({
            name: 'loginBackEvent'
        });
    });
    window.setTimeout(function() {
        openBackPage('会员登录', '/html/login/login.html', {
            bgColor: '#FFF'
        }, {
            type: "movein", //动画类型（详见动画类型常量）
            subType: "from_bottom", //动画子类型（详见动画子类型常量）
            duration: 300 //动画过渡时间，默认300毫秒
        });
    }, 100);
}

//简单的判断登录方法：
//is_login：若未登录，是否进行登录
//is_true_judg：是否真实判断（请求服务器判断）
function judgingLogon(cb, is_login, is_true_judg, not_cb) {
    //没有SID的肯定没登录
    var sid = get_cache(cfg.cache_type.sid);
    if (!sid && is_login) {
        doLogin(cb);
        //未登录方法：
        not_cb && not_cb();
        return;
    }
    if (is_true_judg) {
        //请求服务器接口：
        networkRequest('/member_info/check_member_login', function(ret) {
            if (ret.status == cfg.status.success) {
                cb && cb();
            } else {
                not_cb && not_cb();
                if (is_login) {
                    doLogin(cb);
                }
            }
        }, '', false, true);
    } else if (sid) {
        cb && cb();
    } else if (is_login) {
        doLogin(cb);
    }
}

function show_toast(str) {
    if (!str) {
        return false;
    }
    api.toast({
        msg: str,
        duration: 1500,
        location: 'middle',
        global: true
    });
}

function show_loding() {
    var show_load = $api.byId('show_load');
    if (show_load) {
        $api.html(show_load, '<div id="load-data-box" class="clearfix"><span class="loading"><img src="' + getRelativePath('/image/loading_more.gif') + '" width="16" height="16">&nbsp;正在载入……</span></div>');
    } else {
        //加载提示：
        api.showProgress({
            title: '努力加载中...',
            text: '先喝杯茶...',
            modal: false
        });
    }
}


function hide_loding() {
    api.hideProgress();
}

function show_no_more(str) {
    var show_load = $api.byId('show_load');
    if (show_load) {
        $api.html(show_load, '<div id="load-data-box" class="clearfix"><span class="loading">' + str + '</span></div>');
    } else {
        show_toast(str);
    }
}

function show_no_records(str) {
    var show_load = $api.byId('show_load');
    if (show_load) {

        $api.html(show_load, '<img src="' + getRelativePath('/image/data_tip.png') + '" class="data_tip_img"><div class="data_tip_str">' + str + '</div>');

    }
}

//普通表单提示信息
function form_tip(str) {
    api.toast({
        msg: str,
        duration: 1000,
        location: 'middle',
    });
    return false;
}

//alert提示框
function show_alert(content, funSuc) {
    console.log(content);
    //内容处理：
    content = content + '';
    //替换换行
    content = content.replace(/<br>/gi, '\r\n');
    content = content.replace(/<br\/>/gi, '\r\n');
    content = content.replace(/<br \/>/gi, '\r\n');

    //清除HTML：
    content = content.replace(/<[^>]+>/g, "");

    //提示框：
    api.alert({
        title: '提示',
        msg: content,
    }, function(ret, err) {
        funSuc && funSuc();
    });
}

//alert提示框
function show_confirm(content, okSuc, cancelSuc) {
    api.confirm({
        title: '提示',
        msg: content,
        buttons: ['确定', '取消']
    }, function(ret, err) {
        var index = ret.buttonIndex;
        if (index == 1) {
            okSuc && okSuc();
        } else {
            cancelSuc && cancelSuc();
        }
    });
}

//根据绝对路径获取相对路径
function getRelativePath(url) {
    var params = api.pageParam;
    if (params && params.url_depth) {
        var dot = [];
        for (var i = 0; i < params.url_depth; i++) {
            dot.push('..');
        }
        return dot.join('/') + url;
    } else {
        return '../..' + url;
    }
}

//打开城市选择：
function openCitySelect(cb) {
    //移除事件监听
    api.removeEventListener({
        name: 'selectCityEvent'
    });
    //添加事件监听
    api.addEventListener({
        name: 'selectCityEvent'
    }, function(ret, err) {
        if (ret && ret.value) {
            cb && cb(ret.value);
        }
        //移除事件监听
        api.removeEventListener({
            name: 'selectCityEvent'
        });
    });

    openBackPage('城市选择', '/html/public/select_city.html', {
        bounces: 'NO'
    });
}

//设置下拉刷新：
function setCustomRefreshHeaderInfo(cb) {
    api.setCustomRefreshHeaderInfo({
        bgColor: '#f0f0f0',
        isScale: true,
        loadAnimInterval: 100,
        image: {
            pull: [
                'widget://image/refresh/loding_gif_1.png',
                'widget://image/refresh/loding_gif_2.png',
                'widget://image/refresh/loding_gif_3.png',
                'widget://image/refresh/loding_gif_4.png'
            ],
            load: [
                'widget://image/refresh/loding_gif_1.png',
                'widget://image/refresh/loding_gif_2.png',
                'widget://image/refresh/loding_gif_3.png',
                'widget://image/refresh/loding_gif_4.png'
            ]
        }
    }, function() {
        cb && cb();
    });
}

//打开页面地址：
function openBackPage(winTitle, winUrl, param, animation, slidBackEnabled) {
    if (!param || param.length == 0) {
        param = {};
    }
    param.url = winUrl;
    param.winTitle = winTitle;

    //获取窗口名称：加上参数，防止窗口冲突：
    var winName = winUrl;
    if (param) {
        try {
            winName += JSON.stringify(param);
        } catch (e) {}
    }
    winName = md5(winName);
    //console.log('打开窗口：' +  winUrl + '//' + winName);

    //打开窗口：
    api.openWin({
        name: winName,
        url: 'widget://html/public/back_page.html',
        bounces: false,
        bgColor: param.bgColor ? param.bgColor : '#F0F0F0',
        allowEdit: true,
        pageParam: param,
        animation: animation,
        slidBackEnabled: slidBackEnabled
    });
}

//打开多选选择：
function openMultiSelect(name, cb, param) {
    //移除事件监听
    api.removeEventListener({
        name: 'multiSelectBackEvent'
    });
    //添加事件监听
    api.addEventListener({
        name: 'multiSelectBackEvent'
    }, function(ret, err) {
        if (ret && ret.value) {
            cb && cb(ret.value);
        }
        //移除事件监听
        api.removeEventListener({
            name: 'multiSelectBackEvent'
        });
    });
    openBackPage(name, '/html/public/select_multi.html', param);
}

//打开单选选择：
function openSingleSelect(name, cb, param) {
    //移除事件监听
    api.removeEventListener({
        name: 'singleSelectBackEvent'
    });
    //添加事件监听
    api.addEventListener({
        name: 'singleSelectBackEvent'
    }, function(ret, err) {
        if (ret && ret.value) {
            cb && cb(ret.value);
        }
        //移除事件监听
        api.removeEventListener({
            name: 'singleSelectBackEvent'
        });
    });
    openBackPage(name, '/html/public/select_single.html', param);
}

function openApp(str) {
    if (api.systemType == 'ios') {
        api.openApp({
            iosUrl: str
        });
    } else {
        api.openApp({
            androidPkg: str
        }, function(ret, err) {});
    }
}

function openAppUrl(winUrl) {
    if (api.systemType == 'ios') {
        api.openApp({
            iosUrl: winUrl
        });
    } else {
        api.openApp({
            androidPkg: 'android.intent.action.VIEW',
            uri: winUrl
        }, function(ret, err) {});
    }
}

//图片浏览器：
function showPhotoBrowser(images, index) {
    api.openWin({
        name: 'show_photo',
        url: 'widget://html/public/show_photo.html',
        bounces: false,
        bgColor: '#000',
        allowEdit: true,
        pageParam: {
            images: images,
            index: index
        },
        animation: {
            type: "fade", //动画类型（详见动画类型常量）
            duration: 200 //动画过渡时间，默认300毫秒
        }
    });
}

//字符串搜索处理
function string_search(current_str, search_str) {
    if (!current_str || !search_str) {
        return false;
    }
    //去除空格（二个空格不一样的。）
    current_str = (current_str + '').replace(/ /g, '').replace(/ /g, '');
    var _search = true;
    for (var i = 0; i < current_str.length; i++) {
        if (search_str.indexOf(current_str.substr(i, 1)) == -1) {
            _search = false;
            break;
        }
    }
    return _search;
}

//解析JSON字符串
function parseJSON(str) {
    var json = {};
    if (str) {
        try {
            json = JSON.parse((str + '').replace(/&quot;/g, '"'));
        } catch (e) {}
    }
    return json;
}

function timestampToTime(timestamp, not_date) {
    var date = new Date(timestamp * 1000); //时间戳为10位需*1000，时间戳为13位的话不需乘1000
    Y = date.getFullYear() + '-';
    M = (date.getMonth() + 1 < 10 ? '0' + (date.getMonth() + 1) : date.getMonth() + 1) + '-';
    D = change(date.getDate()) + ' ';
    h = change(date.getHours()) + ':';
    m = change(date.getMinutes()) + ':';
    s = change(date.getSeconds());
    if (not_date) {
        return h + m + s;
    } else {
        return Y + M + D + h + m + s;
    }
}

function change(t) {
    if (t < 10) {
        return "0" + t;
    } else {
        return t;
    }
}


function getDomain(url) {
    var pos = url.indexOf('://');
    if (pos >= 0) {
        pos += '://'.length;
        url = url.slice(pos);
    }
    var array = url.split("/");
    url = array[0];

    //去除二级域名：
    var pos = url.indexOf('.');
    if (pos >= 0) {
        pos += '.'.length;
        url = url.slice(pos);
    }

    return url;
}


//获取定位方法：
function getLocation(cb) {
    //测试信息：
    //locationToCity('31.871481', '117.292846', cb);
    //return false;
    hasAndReqPermission('location', '定位', function() {
        var bMap = api.require('bMap');
        bMap.getLocation({
            accuracy: '100m',
            autoStop: true,
            filter: 1
        }, function(ret, err) {
            console.log('getLocation-ret:' + JSON.stringify(ret));
            console.log('getLocation-err:' + JSON.stringify(err));
            if (ret.status) {
                //存储当前坐标信息
                set_cache(cfg.cache_type.location_lat, ret.lat);
                set_cache(cfg.cache_type.location_lng, ret.lon);

                locationToCity(ret.lat, ret.lon, cb);
            } else {
                cb && cb({
                    status: cfg.status.error,
                    info: '定位失败'
                });
            }
        });
    });
}

function openMapToAddress(address) {
    api.actionSheet({
        title: '地图查看',
        cancelTitle: '取消',
        buttons: ['百度地图', '高德地图']
    }, function(ret, err) {
        var index = ret.buttonIndex;
        if (index == 1) {
            if (api.systemType == 'ios') {
                api.openApp({
                    iosUrl: 'baidumap://map/geocoder?address=' + address + '&src=ios.school51.student'
                });
            } else {
                api.openApp({
                    androidPkg: 'android.intent.action.VIEW',
                    uri: 'baidumap://map/geocoder?src=android.school51.student&address=' + address + '"'
                }, function(ret, err) {});
            }
        } else if (index == 2) {
            if (api.systemType == 'ios') {
                api.openApp({
                    iosUrl: 'iosamap://poi?sourceApplication=蚂蚁兼职&name=' + address
                });
            } else {
                api.openApp({
                    androidPkg: 'com.autonavi.minimap',
                    uri: 'androidamap://poi?sourceApplication=蚂蚁兼职&keywords=' + address + '&dev=0'
                }, function(ret, err) {});
            }
        }
    });
}

function openMapToLocation(title, address, latitude, longitude) {
    if (api.systemType == 'ios') {
        api.openApp({
            iosUrl: 'baidumap://map/marker?location=' + latitude + ',' + longitude + '&title=' + title + '&content=' + address + '&traffic=on&src=android.school51.student'
        });
    } else {
        api.openApp({
            androidPkg: 'android.intent.action.VIEW',
            uri: 'baidumap://map/marker?location=' + latitude + ',' + longitude + '&title=' + title + '&content=' + address + '&traffic=on&src=android.school51.student'
        }, function(ret, err) {});
    }
}

//根据坐标获取城市信息：
function locationToCity(lat, lon, cb) {
    //根据坐标信息，获取城市数据：
    networkRequest('/base/get_city?latitude=' + lat + '&longitude=' + lon, function(ret) {
        if (ret.status == cfg.status.success) {
            //存储相关信息：
            set_cache(cfg.cache_type.location_city_name, ret.data.city_short_name);
            set_cache(cfg.cache_type.location_city_code, ret.data.city_code);

            cb && cb(ret);
        } else {
            cb && cb({
                status: cfg.status.error,
                info: '未找到当前城市'
            });
        }
    });
}

//根据key保存用户资料：
function save_user_info(key, val, cb) {
    networkRequest('/member_info/set_keyvaluserinfo', function(ret) {
        if (ret.status == cfg.status.success) {
            show_toast(ret.info);

            cb && cb();
        }
    }, {
        values: {
            key: key,
            val: val
        }
    }, true);
}

//更新相关代码
//检查更新：
function get_update(is_auto) {
    if (api.debug && is_auto) {
        return false;
    }
    //调用网络请求方法：
    networkRequest('/base/get_update', function(ret) {
        if (ret.status == cfg.status.success) {
            get_update_tip(ret.data, is_auto);
        }
    });
}

function get_update_tip(data, is_auto) {
    if (api.debug && is_auto) {
        return false;
    }
    var appVersion = parseInt((api.appVersion + '').replace(/\./g, ''));
    if (appVersion < parseInt(data.version)) {
        api.confirm({
            title: '更新提示',
            msg: data.content,
            buttons: ['立即更新', '忽略']
        }, function(r, err) {
            if (r.buttonIndex == 1) {
                //下载APP并安装：
                if (api.systemType == 'ios') {
                    api.installApp({
                        appUri: data.download
                    });
                } else {
                    downloadAPP(data.download);
                }
            }
        });
    } else if (!is_auto) {
        show_alert('当前APP已经是最新版本！');
    }
}

function downloadAPP(url) {
    var UIActionProgress = api.require('UIActionProgress');
    UIActionProgress.open({
        maskBg: 'rgba(0,0,0,0.5)',
        styles: {
            h: 108,
            bg: '#fff',
            title: {
                size: 14,
                color: '#000',
                marginT: 10
            },
            msg: {
                size: 12,
                color: '#666',
                marginT: 5
            },
            lable: {
                size: 12,
                color: '#696969',
                marginB: 5
            },
            progressBar: {
                size: 4,
                normal: '#ccc',
                active: '#03a9f4',
                marginB: 15,
                margin: 5
            }
        },
        data: {
            title: '下载中',
            msg: '',
            value: 0
        }
    }, function(res) {
        if (res.eventType == 'show') {
            //这里应该是调用api.download去下载一个文件，然后根据api.download中的回调下载进度去修改模块参数；
            api.download({
                url: url,
                savePath: 'fs://myjz.apk',
                report: true,
                cache: false,
                allowResume: false
            }, function(ret, err) {
                if (ret.state == 0) {
                    var timer = setInterval(function() {
                        //修改参数
                        setProgressData(ret.percent);
                        clearInterval(timer);
                    }, 500);
                }
                if (ret.state == 1) {
                    //关闭循环
                    clearInterval(timer);
                    //关闭下载框
                    closeUIActionProgress();
                    //下载成功
                    api.installApp({
                        appUri: 'fs://myjz.apk'
                    });
                } else if (ret.state == 2) {
                    show_alert('下载失败，请稍候重试……');
                }
            });
        }
    });
}
//修改参数
function setProgressData(value) {
    var UIActionProgress = api.require('UIActionProgress');
    if (value == 100) {
        UIActionProgress.setData({
            data: {
                title: '下载完成',
                msg: '',
                value: value
            }
        });
        setTimeout(function() {
            //关闭进度条模块
            closeUIActionProgress();
        }, 300);
    } else {
        //修改进度条参数
        UIActionProgress.setData({
            data: {
                title: '下载中',
                msg: '',
                value: value
            }
        });
    }
};

//关闭模块
function closeUIActionProgress() {
    var UIActionProgress = api.require('UIActionProgress');
    UIActionProgress.close();
};

//判断数组是否包含项目
function array_contain(array, obj) {
    for (var i = 0; i < array.length; i++) {
        if (array[i] == obj) //如果要求数据类型也一致，这里可使用恒等号===
            return true;
    }
    return false;
}

//APP推送相关方法：
var appPush = {
    //首页的推送各类监听方法；
    indexInit: function(listener) {
        var ajpush = api.require('ajpush');

        //设置监听：
        ajpush.setListener(
            function(ret) {
                listener && listener(ret);

                //消息监听处理：
                appPush.handlePush(ret, false);
            }
        );

        //点击消息监听（安卓）
        api.addEventListener({
            name: 'appintent'
        }, function(ret, err) {
            if (ret && ret.appParam.ajpush) {
                appPush.handlePush(ret.appParam.ajpush, true);
            }
        });
        //点击消息监听（苹果）
        api.addEventListener({
            name: 'noticeclicked'
        }, function(ret, err) {
            if (ret && ret.value) {
                appPush.handlePush(ret.value, true);
            }
        })

        //APP进入后台：
        api.addEventListener({
            name: 'pause'
        }, function(ret, err) {
            ajpush.onPause();
        });

        //APP恢复显示：
        api.addEventListener({
            name: 'resume'
        }, function(ret, err) {
            ajpush.onResume();
            api.sendEvent({
                name: 'addSendMsg'
            });
        })
    },
    //注册推送：
    registerPush: function(member_id, tags) {
        var ajpush = api.require('ajpush');

        //判断是否停止接收消息:
        ajpush.isPushStopped(function(ret) {
            if (ret && ret.isStopped) {
                //恢复接收推送：
                ajpush.resumePush(function(ret) {
                    if (ret && ret.status) {
                        //success
                    }
                });
            }
        });

        //绑定别名与关键字：
        appPush.bindAliasAndTags(member_id, tags);

        //获取注册号：
        ajpush.getRegistrationId(function(ret) {
            var registrationId = ret.id;
            //记录注册号:
            networkRequest('/member_login/set_token', function(ret) {}, {
                values: {
                    'member_id': member_id,
                    'token': registrationId
                }
            });
        });
    },
    //取消注册：
    unRegisterPush: function() {
        //停止接收推送：（暂时退出不停止接收）
        // appPush.stopPush();
    },
    bindAliasAndTags: function(member_id, tags) {
        var ajpush = api.require('ajpush');
        param = {};
        //注册别名与关键字：
        if (member_id) {
            param['alias'] = 'member' + member_id;
        }
        if (tags) {
            param['tags'] = tags;
        }
        ajpush.bindAliasAndTags(param, function(ret) {
            var statusCode = ret.statusCode;
        });
    },
    //停止接收消息
    stopPush: function(cb) {
        var ajpush = api.require('ajpush');
        ajpush.stopPush(function(ret) {
            if (ret && ret.status) {
                cb && cb();
            }
        });
    },
    //恢复接收消息
    resumePush: function(cb) {
        var ajpush = api.require('ajpush');
        ajpush.resumePush(function(ret) {
            if (ret && ret.status) {
                cb && cb();
            }
        });
    },
    //设置角标：
    setBadge: function(num) {
        var ajpush = api.require('ajpush');
        ajpush.setBadge({
            badge: num
        });
    },
    //接收的消息处理：
    //is_click：是否点击状态栏过来的
    handlePush: function(msg, is_click) {
        console.log('handlePush//' + JSON.stringify(msg) + '//' + is_click);
        // var id = msg.id;
        // var title = msg.title;
        // var content = msg.content;
        // var extra = msg.extra;
        //判断附属处理方案：
        //暂时只有点击状态栏才进行处理：
        if (is_click) {
            var extra = msg.extra;
            //打开页面：
            if (extra && extra.page) {
                try {
                    var page = JSON.parse(extra.page);
                    openBackPage(page.title, page.url, page.param, page.animation);
                } catch (e) {}
            }
        } else {
            //显示到状态栏：
            api.notification({
                notify: {
                    title: msg.title,
                    content: msg.content,
                    extra: msg
                }
            });
        }
        api.sendEvent({
            name: 'addSendMsg'
        });
    }
};


//根据类型和ID获取分享数据：
//share_type：1、App直接分享, 2、网页分享  ，10、兼职，20、活动，30、培训
function getShareData(share_type, detail_id) {
    networkRequest('/share/get_share_data?data_type=' + share_type + '&detail_id=' + detail_id, function(ret) {
        if (ret.status == cfg.status.success) {
            openShare(share_type, ret.data.share_url, ret.data.share_title, ret.data.share_text, ret.data.share_img);
        }
    }, '', true);
}

//分享处理：
//打开分享弹窗
//share_type：1、App直接分享, 2、网页分享  ，10、兼职，20、活动，30、培训
function openShare(share_type, url, title, description, img_url) {
    url = url ? url : 'http://mo.school51.com/download';
    title = title ? title : '来自于蚂蚁兼职的分享';
    description = description ? description : '蚂蚁兼职——你身边的兼职神器！' + url;
    img_url = img_url ? img_url : 'http://h5.school51.com/Public/html5/images/logo.png';
    api.openFrame({
        name: 'share',
        url: 'widget://html/public/share.html',
        bgColor: 'rgba(100,100,100,0.5)',
        rect: {
            x: 0,
            y: 0,
            w: 'auto',
            h: 'auto'
        },
        pageParam: {
            share_type: share_type,
            url: url,
            title: title,
            description: description,
            img_url: img_url
        },
        bounces: false,
        animation: {
            type: "movein", //动画类型（详见动画类型常量）
            subType: "from_bottom", //动画子类型（详见动画子类型常量）
            duration: 200 //动画过渡时间，默认300毫秒
        }
    });
}

//拨打电话
function callTel(number, is_tel) {
    if (is_tel) {
        //请求权限判断：
        hasAndReqPermission('phone', '拨打电话', function() {
            api.call({
                type: 'tel_prompt',
                number: number
            });
        });
        return;
    }
    api.actionSheet({
            cancelTitle: '取消',
            buttons: ['拨打电话', '联系QQ', '复制号码']
        },
        function(ret, err) {
            var index = ret.buttonIndex;
            if (index == 1) {
                //请求权限判断：
                hasAndReqPermission('phone', '拨打电话', function() {
                    api.call({
                        type: 'tel_prompt',
                        number: number
                    });
                });
            } else if (index == 2) {
                openAppUrl('mqq://im/chat?chat_type=wpa&uin=' + number + '&version=1&src_type=web');
            } else if (index == 3) {
                var clipBoard = api.require('clipBoard');
                clipBoard.set({
                    value: number
                }, function(ret, err) {});
                show_toast('号码已复制！');
            }
        });
}

//显示支付界面
function openAppPay(pay_id, cb) {
    //移除事件监听
    api.removeEventListener({
        name: 'appPayBackEvent'
    });
    //添加事件监听
    api.addEventListener({
        name: 'appPayBackEvent'
    }, function(ret, err) {
        cb && cb();
        //移除事件监听
        api.removeEventListener({
            name: 'appPayBackEvent'
        });
    });
    api.openFrame({
        name: 'app_pay',
        url: 'widget://html/public/app_pay.html',
        bgColor: 'rgba(100,100,100,0.5)',
        rect: {
            x: 0,
            y: 0,
            w: 'auto',
            h: 'auto'
        },
        pageParam: {
            pay_id: pay_id
        },
        bounces: false,
        animation: {
            type: "movein", //动画类型（详见动画类型常量）
            subType: "from_bottom", //动画子类型（详见动画子类型常量）
            duration: 200 //动画过渡时间，默认300毫秒
        }
    });
}

//图片缓存方法：
function getCacheImage(url) {
    if (!url) {
        return '';
    }

    //获取缓存保存目录：
    var file_name = 'cache://image_cache/' + md5(url);


    //判断文件是否存在：
    var fs = api.require('fs');
    var ret = fs.existSync({
        path: file_name
    });
    if (ret.exist) {
        //console.log('file_name===' + file_name);
        if (api.systemType == 'ios') {
            return file_name;
        } else {
            //安卓的要转换路径才能显示：
            var ret = fs.openSync({
                path: file_name,
                flags: 'read'
            });
            if (ret.status) {
                //console.log('file_name.ret.fd===' + ret.fd);
                return ret.fd;
            }
            return url;
        }
    }
    //下载图片：
    downCacheImage(url, file_name);
    //console.log('url==' + url);
    return url;
}

//下载图片缓存：
function downCacheImage(url, file_name, cb) {
    api.download({
        url: url,
        savePath: file_name,
        report: true,
        cache: true,
        allowResume: true
    }, function(ret, err) {
        //console.log('download' + JSON.stringify(ret));
        if (ret.state == 1) {
            cb && cb();
        }
    });
}

//转为为分钟显示：
function show_minute(time) {
    if (time > 3600) {
        var second = (time % 60);
        if (second < 10) {
            second = '0' + second;
        }
        var hour = parseInt((time % 3600) / 60);
        if (hour < 10) {
            hour = '0' + hour;
        }
        return parseInt(time / 3600) + ':' + hour + ':' + second;
    } else if (time > 60) {
        var second = (time % 60);
        if (second < 10) {
            second = '0' + second;
        }
        return parseInt(time / 60) + ':' + second;
    } else {
        return time + '″';
    }
}

//=======================红点相关管理类=======================
var redDot = {
    //配置信息
    cfg: {
        db_name: 'red_db',
        table_name: 'red_dot_1_0'
    },
    init: function() {
        //打开或者创建数据库：
        var db = api.require('db');
        var ret = db.openDatabaseSync({
            name: redDot.cfg.db_name
        });
        //alert('打开数据库：' + JSON.stringify(ret));

        //创建表：
        var ret = db.executeSqlSync({
            name: redDot.cfg.db_name,
            sql: 'CREATE TABLE ' + redDot.cfg.table_name + '(tag varchar(255),red_num int, update_time int)'
        });
        //alert('创建数据表：' + JSON.stringify(ret));
    },
    //根据标识，获取原始记录
    get_res: function(tag) {
        var db = api.require('db');
        var ret = db.selectSqlSync({
            name: redDot.cfg.db_name,
            sql: 'SELECT * FROM ' + redDot.cfg.table_name + ' WHERE tag = \'' + tag + '\''
        });
        //alert('数据查询：' + JSON.stringify(ret));
        if (ret.data.length > 0) {
            return ret.data[0]
        } else {
            return false;
        }
    },
    //根清除所有红点记录：
    clean_all_res: function() {
        var db = api.require('db');
        var ret = db.selectSqlSync({
            name: redDot.cfg.db_name,
            sql: 'DELETE FROM ' + redDot.cfg.table_name
        });
    },
    //根据标识，查询红点总数
    get_num: function(tag) {
        var db = api.require('db');
        var ret = db.selectSqlSync({
            name: redDot.cfg.db_name,
            sql: 'SELECT SUM(red_num) AS red_num FROM ' + redDot.cfg.table_name + ' WHERE tag like \'' + tag + '%\''
        });
        //alert(tag + '数据查询：' + JSON.stringify(ret));
        if (ret.data.length > 0) {
            return ret.data[0].red_num ? parseInt(ret.data[0].red_num) : 0;
        } else {
            return 0;
        }
    },
    //批量设置红点数字：(没有返回值的)
    set_num_batch: function(data, clean_all) {
        if (clean_all) {
            redDot.clean_all_res();
        }

        //循环处理：
        for (var i = 0; i < data.length; i++) {
            redDot.set_num(data[i].tag, data[i].red_num);
        }

        //发送事件：
        api.sendEvent({
            name: 'reddot_update',
            tag: 'all'
        });
    },

    //根据标签，设置红点数字
    set_num: function(tag, red_num) {
        //当前时间戳：用户更新时间
        var timestamp = Date.parse(new Date()) / 1000;

        //调用模块：
        var db = api.require('db');
        //先查询是否有记录：
        var ret = db.selectSqlSync({
            name: redDot.cfg.db_name,
            sql: 'SELECT * FROM ' + redDot.cfg.table_name + ' WHERE tag = \'' + tag + '\''
        });

        var ret_two;
        if (ret.data.length > 0) {
            //更新数据
            ret_two = db.executeSqlSync({
                name: redDot.cfg.db_name,
                sql: 'UPDATE ' + redDot.cfg.table_name + ' SET red_num = ' + red_num + ',update_time = ' + timestamp + ' WHERE tag = \'' + tag + '\''
            });
        } else {
            //插入数据：
            ret_two = db.executeSqlSync({
                name: redDot.cfg.db_name,
                sql: 'INSERT INTO ' + redDot.cfg.table_name + ' (tag, red_num,update_time) VALUES (\'' + tag + '\',' + red_num + ',' + timestamp + ')'
            });
        }
    }
};

//===============FastClick===================
;
(function() {
    'use strict';

    /**
     * @preserve FastClick: polyfill to remove click delays on browsers with touch UIs.
     *
     * @codingstandard ftlabs-jsv2
     * @copyright The Financial Times Limited [All Rights Reserved]
     * @license MIT License (see LICENSE.txt)
     */

    /*jslint browser:true, node:true*/
    /*global define, Event, Node*/


    /**
     * Instantiate fast-clicking listeners on the specified layer.
     *
     * @constructor
     * @param {Element} layer The layer to listen on
     * @param {Object} [options={}] The options to override the defaults
     */
    function FastClick(layer, options) {
        var oldOnClick;

        options = options || {};

        /**
         * Whether a click is currently being tracked.
         *
         * @type boolean
         */
        this.trackingClick = false;


        /**
         * Timestamp for when click tracking started.
         *
         * @type number
         */
        this.trackingClickStart = 0;


        /**
         * The element being tracked for a click.
         *
         * @type EventTarget
         */
        this.targetElement = null;


        /**
         * X-coordinate of touch start event.
         *
         * @type number
         */
        this.touchStartX = 0;


        /**
         * Y-coordinate of touch start event.
         *
         * @type number
         */
        this.touchStartY = 0;


        /**
         * ID of the last touch, retrieved from Touch.identifier.
         *
         * @type number
         */
        this.lastTouchIdentifier = 0;


        /**
         * Touchmove boundary, beyond which a click will be cancelled.
         *
         * @type number
         */
        this.touchBoundary = options.touchBoundary || 10;


        /**
         * The FastClick layer.
         *
         * @type Element
         */
        this.layer = layer;

        /**
         * The minimum time between tap(touchstart and touchend) events
         *
         * @type number
         */
        this.tapDelay = options.tapDelay || 200;

        /**
         * The maximum time for a tap
         *
         * @type number
         */
        this.tapTimeout = options.tapTimeout || 700;

        if (FastClick.notNeeded(layer)) {
            return;
        }

        // Some old versions of Android don't have Function.prototype.bind
        function bind(method, context) {
            return function() {
                return method.apply(context, arguments);
            };
        }


        var methods = ['onMouse', 'onClick', 'onTouchStart', 'onTouchMove', 'onTouchEnd', 'onTouchCancel'];
        var context = this;
        for (var i = 0, l = methods.length; i < l; i++) {
            context[methods[i]] = bind(context[methods[i]], context);
        }

        // Set up event handlers as required
        if (deviceIsAndroid) {
            layer.addEventListener('mouseover', this.onMouse, true);
            layer.addEventListener('mousedown', this.onMouse, true);
            layer.addEventListener('mouseup', this.onMouse, true);
        }

        layer.addEventListener('click', this.onClick, true);
        layer.addEventListener('touchstart', this.onTouchStart, false);
        layer.addEventListener('touchmove', this.onTouchMove, false);
        layer.addEventListener('touchend', this.onTouchEnd, false);
        layer.addEventListener('touchcancel', this.onTouchCancel, false);

        // Hack is required for browsers that don't support Event#stopImmediatePropagation (e.g. Android 2)
        // which is how FastClick normally stops click events bubbling to callbacks registered on the FastClick
        // layer when they are cancelled.
        if (!Event.prototype.stopImmediatePropagation) {
            layer.removeEventListener = function(type, callback, capture) {
                var rmv = Node.prototype.removeEventListener;
                if (type === 'click') {
                    rmv.call(layer, type, callback.hijacked || callback, capture);
                } else {
                    rmv.call(layer, type, callback, capture);
                }
            };

            layer.addEventListener = function(type, callback, capture) {
                var adv = Node.prototype.addEventListener;
                if (type === 'click') {
                    adv.call(layer, type, callback.hijacked || (callback.hijacked = function(event) {
                        if (!event.propagationStopped) {
                            callback(event);
                        }
                    }), capture);
                } else {
                    adv.call(layer, type, callback, capture);
                }
            };
        }

        // If a handler is already declared in the element's onclick attribute, it will be fired before
        // FastClick's onClick handler. Fix this by pulling out the user-defined handler function and
        // adding it as listener.
        if (typeof layer.onclick === 'function') {

            // Android browser on at least 3.2 requires a new reference to the function in layer.onclick
            // - the old one won't work if passed to addEventListener directly.
            oldOnClick = layer.onclick;
            layer.addEventListener('click', function(event) {
                oldOnClick(event);
            }, false);
            layer.onclick = null;
        }
    }

    /**
     * Windows Phone 8.1 fakes user agent string to look like Android and iPhone.
     *
     * @type boolean
     */
    var deviceIsWindowsPhone = navigator.userAgent.indexOf("Windows Phone") >= 0;

    /**
     * Android requires exceptions.
     *
     * @type boolean
     */
    var deviceIsAndroid = navigator.userAgent.indexOf('Android') > 0 && !deviceIsWindowsPhone;


    /**
     * iOS requires exceptions.
     *
     * @type boolean
     */
    var deviceIsIOS = /iP(ad|hone|od)/.test(navigator.userAgent) && !deviceIsWindowsPhone;


    /**
     * iOS 4 requires an exception for select elements.
     *
     * @type boolean
     */
    var deviceIsIOS4 = deviceIsIOS && (/OS 4_\d(_\d)?/).test(navigator.userAgent);


    /**
     * iOS 6.0-7.* requires the target element to be manually derived
     *
     * @type boolean
     */
    var deviceIsIOSWithBadTarget = deviceIsIOS && (/OS [6-7]_\d/).test(navigator.userAgent);

    /**
     * BlackBerry requires exceptions.
     *
     * @type boolean
     */
    var deviceIsBlackBerry10 = navigator.userAgent.indexOf('BB10') > 0;

    /**
     * Determine whether a given element requires a native click.
     *
     * @param {EventTarget|Element} target Target DOM element
     * @returns {boolean} Returns true if the element needs a native click
     */
    FastClick.prototype.needsClick = function(target) {
        switch (target.nodeName.toLowerCase()) {

            // Don't send a synthetic click to disabled inputs (issue #62)
            case 'button':
            case 'select':
            case 'textarea':
                if (target.disabled) {
                    return true;
                }

                break;
            case 'input':

                // File inputs need real clicks on iOS 6 due to a browser bug (issue #68)
                if ((deviceIsIOS && target.type === 'file') || target.disabled) {
                    return true;
                }

                break;
            case 'label':
            case 'iframe': // iOS8 homescreen apps can prevent events bubbling into frames
            case 'video':
                return true;
        }

        return (/\bneedsclick\b/).test(target.className);
    };


    /**
     * Determine whether a given element requires a call to focus to simulate click into element.
     *
     * @param {EventTarget|Element} target Target DOM element
     * @returns {boolean} Returns true if the element requires a call to focus to simulate native click.
     */
    FastClick.prototype.needsFocus = function(target) {
        switch (target.nodeName.toLowerCase()) {
            case 'textarea':
                return true;
            case 'select':
                return !deviceIsAndroid;
            case 'input':
                switch (target.type) {
                    case 'button':
                    case 'checkbox':
                    case 'file':
                    case 'image':
                    case 'radio':
                    case 'submit':
                        return false;
                }

                // No point in attempting to focus disabled inputs
                return !target.disabled && !target.readOnly;
            default:
                return (/\bneedsfocus\b/).test(target.className);
        }
    };


    /**
     * Send a click event to the specified element.
     *
     * @param {EventTarget|Element} targetElement
     * @param {Event} event
     */
    FastClick.prototype.sendClick = function(targetElement, event) {
        var clickEvent, touch;

        // On some Android devices activeElement needs to be blurred otherwise the synthetic click will have no effect (#24)
        if (document.activeElement && document.activeElement !== targetElement) {
            document.activeElement.blur();
        }

        touch = event.changedTouches[0];

        // Synthesise a click event, with an extra attribute so it can be tracked
        clickEvent = document.createEvent('MouseEvents');
        clickEvent.initMouseEvent(this.determineEventType(targetElement), true, true, window, 1, touch.screenX, touch.screenY, touch.clientX, touch.clientY, false, false, false, false, 0, null);
        clickEvent.forwardedTouchEvent = true;
        targetElement.dispatchEvent(clickEvent);
    };

    FastClick.prototype.determineEventType = function(targetElement) {

        //Issue #159: Android Chrome Select Box does not open with a synthetic click event
        if (deviceIsAndroid && targetElement.tagName.toLowerCase() === 'select') {
            return 'mousedown';
        }

        return 'click';
    };


    /**
     * @param {EventTarget|Element} targetElement
     */
    FastClick.prototype.focus = function(targetElement) {
        var length;

        // Issue #160: on iOS 7, some input elements (e.g. date datetime month) throw a vague TypeError on setSelectionRange. These elements don't have an integer value for the selectionStart and selectionEnd properties, but unfortunately that can't be used for detection because accessing the properties also throws a TypeError. Just check the type instead. Filed as Apple bug #15122724.
        if (deviceIsIOS && targetElement.setSelectionRange && targetElement.type.indexOf('date') !== 0 && targetElement.type !== 'time' && targetElement.type !== 'month' && targetElement.type !== 'email') {
            length = targetElement.value.length;
            targetElement.setSelectionRange(length, length);
        } else {
            targetElement.focus();
        }
    };


    /**
     * Check whether the given target element is a child of a scrollable layer and if so, set a flag on it.
     *
     * @param {EventTarget|Element} targetElement
     */
    FastClick.prototype.updateScrollParent = function(targetElement) {
        var scrollParent, parentElement;

        scrollParent = targetElement.fastClickScrollParent;

        // Attempt to discover whether the target element is contained within a scrollable layer. Re-check if the
        // target element was moved to another parent.
        if (!scrollParent || !scrollParent.contains(targetElement)) {
            parentElement = targetElement;
            do {
                if (parentElement.scrollHeight > parentElement.offsetHeight) {
                    scrollParent = parentElement;
                    targetElement.fastClickScrollParent = parentElement;
                    break;
                }

                parentElement = parentElement.parentElement;
            } while (parentElement);
        }

        // Always update the scroll top tracker if possible.
        if (scrollParent) {
            scrollParent.fastClickLastScrollTop = scrollParent.scrollTop;
        }
    };


    /**
     * @param {EventTarget} targetElement
     * @returns {Element|EventTarget}
     */
    FastClick.prototype.getTargetElementFromEventTarget = function(eventTarget) {

        // On some older browsers (notably Safari on iOS 4.1 - see issue #56) the event target may be a text node.
        if (eventTarget.nodeType === Node.TEXT_NODE) {
            return eventTarget.parentNode;
        }

        return eventTarget;
    };


    /**
     * On touch start, record the position and scroll offset.
     *
     * @param {Event} event
     * @returns {boolean}
     */
    FastClick.prototype.onTouchStart = function(event) {
        var targetElement, touch, selection;

        // Ignore multiple touches, otherwise pinch-to-zoom is prevented if both fingers are on the FastClick element (issue #111).
        if (event.targetTouches.length > 1) {
            return true;
        }

        targetElement = this.getTargetElementFromEventTarget(event.target);
        touch = event.targetTouches[0];

        if (deviceIsIOS) {

            // Only trusted events will deselect text on iOS (issue #49)
            selection = window.getSelection();
            if (selection.rangeCount && !selection.isCollapsed) {
                return true;
            }

            if (!deviceIsIOS4) {

                // Weird things happen on iOS when an alert or confirm dialog is opened from a click event callback (issue #23):
                // when the user next taps anywhere else on the page, new touchstart and touchend events are dispatched
                // with the same identifier as the touch event that previously triggered the click that triggered the alert.
                // Sadly, there is an issue on iOS 4 that causes some normal touch events to have the same identifier as an
                // immediately preceeding touch event (issue #52), so this fix is unavailable on that platform.
                // Issue 120: touch.identifier is 0 when Chrome dev tools 'Emulate touch events' is set with an iOS device UA string,
                // which causes all touch events to be ignored. As this block only applies to iOS, and iOS identifiers are always long,
                // random integers, it's safe to to continue if the identifier is 0 here.
                if (touch.identifier && touch.identifier === this.lastTouchIdentifier) {
                    event.preventDefault();
                    return false;
                }

                this.lastTouchIdentifier = touch.identifier;

                // If the target element is a child of a scrollable layer (using -webkit-overflow-scrolling: touch) and:
                // 1) the user does a fling scroll on the scrollable layer
                // 2) the user stops the fling scroll with another tap
                // then the event.target of the last 'touchend' event will be the element that was under the user's finger
                // when the fling scroll was started, causing FastClick to send a click event to that layer - unless a check
                // is made to ensure that a parent layer was not scrolled before sending a synthetic click (issue #42).
                this.updateScrollParent(targetElement);
            }
        }

        this.trackingClick = true;
        this.trackingClickStart = event.timeStamp;
        this.targetElement = targetElement;

        this.touchStartX = touch.pageX;
        this.touchStartY = touch.pageY;

        // Prevent phantom clicks on fast double-tap (issue #36)
        if ((event.timeStamp - this.lastClickTime) < this.tapDelay) {
            event.preventDefault();
        }

        return true;
    };


    /**
     * Based on a touchmove event object, check whether the touch has moved past a boundary since it started.
     *
     * @param {Event} event
     * @returns {boolean}
     */
    FastClick.prototype.touchHasMoved = function(event) {
        var touch = event.changedTouches[0],
            boundary = this.touchBoundary;

        if (Math.abs(touch.pageX - this.touchStartX) > boundary || Math.abs(touch.pageY - this.touchStartY) > boundary) {
            return true;
        }

        return false;
    };


    /**
     * Update the last position.
     *
     * @param {Event} event
     * @returns {boolean}
     */
    FastClick.prototype.onTouchMove = function(event) {
        if (!this.trackingClick) {
            return true;
        }

        // If the touch has moved, cancel the click tracking
        if (this.targetElement !== this.getTargetElementFromEventTarget(event.target) || this.touchHasMoved(event)) {
            this.trackingClick = false;
            this.targetElement = null;
        }

        return true;
    };


    /**
     * Attempt to find the labelled control for the given label element.
     *
     * @param {EventTarget|HTMLLabelElement} labelElement
     * @returns {Element|null}
     */
    FastClick.prototype.findControl = function(labelElement) {

        // Fast path for newer browsers supporting the HTML5 control attribute
        if (labelElement.control !== undefined) {
            return labelElement.control;
        }

        // All browsers under test that support touch events also support the HTML5 htmlFor attribute
        if (labelElement.htmlFor) {
            return document.getElementById(labelElement.htmlFor);
        }

        // If no for attribute exists, attempt to retrieve the first labellable descendant element
        // the list of which is defined here: http://www.w3.org/TR/html5/forms.html#category-label
        return labelElement.querySelector('button, input:not([type=hidden]), keygen, meter, output, progress, select, textarea');
    };


    /**
     * On touch end, determine whether to send a click event at once.
     *
     * @param {Event} event
     * @returns {boolean}
     */
    FastClick.prototype.onTouchEnd = function(event) {
        var forElement, trackingClickStart, targetTagName, scrollParent, touch, targetElement = this.targetElement;

        if (!this.trackingClick) {
            return true;
        }

        // Prevent phantom clicks on fast double-tap (issue #36)
        if ((event.timeStamp - this.lastClickTime) < this.tapDelay) {
            this.cancelNextClick = true;
            return true;
        }

        if ((event.timeStamp - this.trackingClickStart) > this.tapTimeout) {
            return true;
        }

        // Reset to prevent wrong click cancel on input (issue #156).
        this.cancelNextClick = false;

        this.lastClickTime = event.timeStamp;

        trackingClickStart = this.trackingClickStart;
        this.trackingClick = false;
        this.trackingClickStart = 0;

        // On some iOS devices, the targetElement supplied with the event is invalid if the layer
        // is performing a transition or scroll, and has to be re-detected manually. Note that
        // for this to function correctly, it must be called *after* the event target is checked!
        // See issue #57; also filed as rdar://13048589 .
        if (deviceIsIOSWithBadTarget) {
            touch = event.changedTouches[0];

            // In certain cases arguments of elementFromPoint can be negative, so prevent setting targetElement to null
            targetElement = document.elementFromPoint(touch.pageX - window.pageXOffset, touch.pageY - window.pageYOffset) || targetElement;
            targetElement.fastClickScrollParent = this.targetElement.fastClickScrollParent;
        }

        targetTagName = targetElement.tagName.toLowerCase();
        if (targetTagName === 'label') {
            forElement = this.findControl(targetElement);
            if (forElement) {
                this.focus(targetElement);
                if (deviceIsAndroid) {
                    return false;
                }

                targetElement = forElement;
            }
        } else if (this.needsFocus(targetElement)) {

            // Case 1: If the touch started a while ago (best guess is 100ms based on tests for issue #36) then focus will be triggered anyway. Return early and unset the target element reference so that the subsequent click will be allowed through.
            // Case 2: Without this exception for input elements tapped when the document is contained in an iframe, then any inputted text won't be visible even though the value attribute is updated as the user types (issue #37).
            if ((event.timeStamp - trackingClickStart) > 100 || (deviceIsIOS && window.top !== window && targetTagName === 'input')) {
                this.targetElement = null;
                return false;
            }

            this.focus(targetElement);
            this.sendClick(targetElement, event);

            // Select elements need the event to go through on iOS 4, otherwise the selector menu won't open.
            // Also this breaks opening selects when VoiceOver is active on iOS6, iOS7 (and possibly others)
            if (!deviceIsIOS || targetTagName !== 'select') {
                this.targetElement = null;
                event.preventDefault();
            }

            return false;
        }

        if (deviceIsIOS && !deviceIsIOS4) {

            // Don't send a synthetic click event if the target element is contained within a parent layer that was scrolled
            // and this tap is being used to stop the scrolling (usually initiated by a fling - issue #42).
            scrollParent = targetElement.fastClickScrollParent;
            if (scrollParent && scrollParent.fastClickLastScrollTop !== scrollParent.scrollTop) {
                return true;
            }
        }

        // Prevent the actual click from going though - unless the target node is marked as requiring
        // real clicks or if it is in the whitelist in which case only non-programmatic clicks are permitted.
        if (!this.needsClick(targetElement)) {
            event.preventDefault();
            this.sendClick(targetElement, event);
        }

        return false;
    };


    /**
     * On touch cancel, stop tracking the click.
     *
     * @returns {void}
     */
    FastClick.prototype.onTouchCancel = function() {
        this.trackingClick = false;
        this.targetElement = null;
    };


    /**
     * Determine mouse events which should be permitted.
     *
     * @param {Event} event
     * @returns {boolean}
     */
    FastClick.prototype.onMouse = function(event) {

        // If a target element was never set (because a touch event was never fired) allow the event
        if (!this.targetElement) {
            return true;
        }

        if (event.forwardedTouchEvent) {
            return true;
        }

        // Programmatically generated events targeting a specific element should be permitted
        if (!event.cancelable) {
            return true;
        }

        // Derive and check the target element to see whether the mouse event needs to be permitted;
        // unless explicitly enabled, prevent non-touch click events from triggering actions,
        // to prevent ghost/doubleclicks.
        if (!this.needsClick(this.targetElement) || this.cancelNextClick) {

            // Prevent any user-added listeners declared on FastClick element from being fired.
            if (event.stopImmediatePropagation) {
                event.stopImmediatePropagation();
            } else {

                // Part of the hack for browsers that don't support Event#stopImmediatePropagation (e.g. Android 2)
                event.propagationStopped = true;
            }

            // Cancel the event
            event.stopPropagation();
            event.preventDefault();

            return false;
        }

        // If the mouse event is permitted, return true for the action to go through.
        return true;
    };


    /**
     * On actual clicks, determine whether this is a touch-generated click, a click action occurring
     * naturally after a delay after a touch (which needs to be cancelled to avoid duplication), or
     * an actual click which should be permitted.
     *
     * @param {Event} event
     * @returns {boolean}
     */
    FastClick.prototype.onClick = function(event) {
        var permitted;

        // It's possible for another FastClick-like library delivered with third-party code to fire a click event before FastClick does (issue #44). In that case, set the click-tracking flag back to false and return early. This will cause onTouchEnd to return early.
        if (this.trackingClick) {
            this.targetElement = null;
            this.trackingClick = false;
            return true;
        }

        // Very odd behaviour on iOS (issue #18): if a submit element is present inside a form and the user hits enter in the iOS simulator or clicks the Go button on the pop-up OS keyboard the a kind of 'fake' click event will be triggered with the submit-type input element as the target.
        if (event.target.type === 'submit' && event.detail === 0) {
            return true;
        }

        permitted = this.onMouse(event);

        // Only unset targetElement if the click is not permitted. This will ensure that the check for !targetElement in onMouse fails and the browser's click doesn't go through.
        if (!permitted) {
            this.targetElement = null;
        }

        // If clicks are permitted, return true for the action to go through.
        return permitted;
    };


    /**
     * Remove all FastClick's event listeners.
     *
     * @returns {void}
     */
    FastClick.prototype.destroy = function() {
        var layer = this.layer;

        if (deviceIsAndroid) {
            layer.removeEventListener('mouseover', this.onMouse, true);
            layer.removeEventListener('mousedown', this.onMouse, true);
            layer.removeEventListener('mouseup', this.onMouse, true);
        }

        layer.removeEventListener('click', this.onClick, true);
        layer.removeEventListener('touchstart', this.onTouchStart, false);
        layer.removeEventListener('touchmove', this.onTouchMove, false);
        layer.removeEventListener('touchend', this.onTouchEnd, false);
        layer.removeEventListener('touchcancel', this.onTouchCancel, false);
    };


    /**
     * Check whether FastClick is needed.
     *
     * @param {Element} layer The layer to listen on
     */
    FastClick.notNeeded = function(layer) {
        var metaViewport;
        var chromeVersion;
        var blackberryVersion;
        var firefoxVersion;

        // Devices that don't support touch don't need FastClick
        if (typeof window.ontouchstart === 'undefined') {
            return true;
        }

        // Chrome version - zero for other browsers
        chromeVersion = +(/Chrome\/([0-9]+)/.exec(navigator.userAgent) || [, 0])[1];

        if (chromeVersion) {

            if (deviceIsAndroid) {
                metaViewport = document.querySelector('meta[name=viewport]');

                if (metaViewport) {
                    // Chrome on Android with user-scalable="no" doesn't need FastClick (issue #89)
                    if (metaViewport.content.indexOf('user-scalable=no') !== -1) {
                        return true;
                    }
                    // Chrome 32 and above with width=device-width or less don't need FastClick
                    if (chromeVersion > 31 && document.documentElement.scrollWidth <= window.outerWidth) {
                        return true;
                    }
                }

                // Chrome desktop doesn't need FastClick (issue #15)
            } else {
                return true;
            }
        }

        if (deviceIsBlackBerry10) {
            blackberryVersion = navigator.userAgent.match(/Version\/([0-9]*)\.([0-9]*)/);

            // BlackBerry 10.3+ does not require Fastclick library.
            // https://github.com/ftlabs/fastclick/issues/251
            if (blackberryVersion[1] >= 10 && blackberryVersion[2] >= 3) {
                metaViewport = document.querySelector('meta[name=viewport]');

                if (metaViewport) {
                    // user-scalable=no eliminates click delay.
                    if (metaViewport.content.indexOf('user-scalable=no') !== -1) {
                        return true;
                    }
                    // width=device-width (or less than device-width) eliminates click delay.
                    if (document.documentElement.scrollWidth <= window.outerWidth) {
                        return true;
                    }
                }
            }
        }

        // IE10 with -ms-touch-action: none or manipulation, which disables double-tap-to-zoom (issue #97)
        if (layer.style.msTouchAction === 'none' || layer.style.touchAction === 'manipulation') {
            return true;
        }

        // Firefox version - zero for other browsers
        firefoxVersion = +(/Firefox\/([0-9]+)/.exec(navigator.userAgent) || [, 0])[1];

        if (firefoxVersion >= 27) {
            // Firefox 27+ does not have tap delay if the content is not zoomable - https://bugzilla.mozilla.org/show_bug.cgi?id=922896

            metaViewport = document.querySelector('meta[name=viewport]');
            if (metaViewport && (metaViewport.content.indexOf('user-scalable=no') !== -1 || document.documentElement.scrollWidth <= window.outerWidth)) {
                return true;
            }
        }

        // IE11: prefixed -ms-touch-action is no longer supported and it's recomended to use non-prefixed version
        // http://msdn.microsoft.com/en-us/library/windows/apps/Hh767313.aspx
        if (layer.style.touchAction === 'none' || layer.style.touchAction === 'manipulation') {
            return true;
        }

        return false;
    };


    /**
     * Factory method for creating a FastClick object
     *
     * @param {Element} layer The layer to listen on
     * @param {Object} [options={}] The options to override the defaults
     */
    FastClick.attach = function(layer, options) {
        return new FastClick(layer, options);
    };


    if (typeof define === 'function' && typeof define.amd === 'object' && define.amd) {

        // AMD. Register as an anonymous module.
        define(function() {
            return FastClick;
        });
    } else if (typeof module !== 'undefined' && module.exports) {
        module.exports = FastClick.attach;
        module.exports.FastClick = FastClick;
    } else {
        window.FastClick = FastClick;
    }
}());


//md5
function md5(string) {
    var x = Array();
    var k, AA, BB, CC, DD, a, b, c, d;
    var S11 = 7,
        S12 = 12,
        S13 = 17,
        S14 = 22;
    var S21 = 5,
        S22 = 9,
        S23 = 14,
        S24 = 20;
    var S31 = 4,
        S32 = 11,
        S33 = 16,
        S34 = 23;
    var S41 = 6,
        S42 = 10,
        S43 = 15,
        S44 = 21;
    string = Utf8Encode(string);
    x = ConvertToWordArray(string);
    a = 0x67452301;
    b = 0xEFCDAB89;
    c = 0x98BADCFE;
    d = 0x10325476;
    for (k = 0; k < x.length; k += 16) {
        AA = a;
        BB = b;
        CC = c;
        DD = d;
        a = FF(a, b, c, d, x[k + 0], S11, 0xD76AA478);
        d = FF(d, a, b, c, x[k + 1], S12, 0xE8C7B756);
        c = FF(c, d, a, b, x[k + 2], S13, 0x242070DB);
        b = FF(b, c, d, a, x[k + 3], S14, 0xC1BDCEEE);
        a = FF(a, b, c, d, x[k + 4], S11, 0xF57C0FAF);
        d = FF(d, a, b, c, x[k + 5], S12, 0x4787C62A);
        c = FF(c, d, a, b, x[k + 6], S13, 0xA8304613);
        b = FF(b, c, d, a, x[k + 7], S14, 0xFD469501);
        a = FF(a, b, c, d, x[k + 8], S11, 0x698098D8);
        d = FF(d, a, b, c, x[k + 9], S12, 0x8B44F7AF);
        c = FF(c, d, a, b, x[k + 10], S13, 0xFFFF5BB1);
        b = FF(b, c, d, a, x[k + 11], S14, 0x895CD7BE);
        a = FF(a, b, c, d, x[k + 12], S11, 0x6B901122);
        d = FF(d, a, b, c, x[k + 13], S12, 0xFD987193);
        c = FF(c, d, a, b, x[k + 14], S13, 0xA679438E);
        b = FF(b, c, d, a, x[k + 15], S14, 0x49B40821);
        a = GG(a, b, c, d, x[k + 1], S21, 0xF61E2562);
        d = GG(d, a, b, c, x[k + 6], S22, 0xC040B340);
        c = GG(c, d, a, b, x[k + 11], S23, 0x265E5A51);
        b = GG(b, c, d, a, x[k + 0], S24, 0xE9B6C7AA);
        a = GG(a, b, c, d, x[k + 5], S21, 0xD62F105D);
        d = GG(d, a, b, c, x[k + 10], S22, 0x2441453);
        c = GG(c, d, a, b, x[k + 15], S23, 0xD8A1E681);
        b = GG(b, c, d, a, x[k + 4], S24, 0xE7D3FBC8);
        a = GG(a, b, c, d, x[k + 9], S21, 0x21E1CDE6);
        d = GG(d, a, b, c, x[k + 14], S22, 0xC33707D6);
        c = GG(c, d, a, b, x[k + 3], S23, 0xF4D50D87);
        b = GG(b, c, d, a, x[k + 8], S24, 0x455A14ED);
        a = GG(a, b, c, d, x[k + 13], S21, 0xA9E3E905);
        d = GG(d, a, b, c, x[k + 2], S22, 0xFCEFA3F8);
        c = GG(c, d, a, b, x[k + 7], S23, 0x676F02D9);
        b = GG(b, c, d, a, x[k + 12], S24, 0x8D2A4C8A);
        a = HH(a, b, c, d, x[k + 5], S31, 0xFFFA3942);
        d = HH(d, a, b, c, x[k + 8], S32, 0x8771F681);
        c = HH(c, d, a, b, x[k + 11], S33, 0x6D9D6122);
        b = HH(b, c, d, a, x[k + 14], S34, 0xFDE5380C);
        a = HH(a, b, c, d, x[k + 1], S31, 0xA4BEEA44);
        d = HH(d, a, b, c, x[k + 4], S32, 0x4BDECFA9);
        c = HH(c, d, a, b, x[k + 7], S33, 0xF6BB4B60);
        b = HH(b, c, d, a, x[k + 10], S34, 0xBEBFBC70);
        a = HH(a, b, c, d, x[k + 13], S31, 0x289B7EC6);
        d = HH(d, a, b, c, x[k + 0], S32, 0xEAA127FA);
        c = HH(c, d, a, b, x[k + 3], S33, 0xD4EF3085);
        b = HH(b, c, d, a, x[k + 6], S34, 0x4881D05);
        a = HH(a, b, c, d, x[k + 9], S31, 0xD9D4D039);
        d = HH(d, a, b, c, x[k + 12], S32, 0xE6DB99E5);
        c = HH(c, d, a, b, x[k + 15], S33, 0x1FA27CF8);
        b = HH(b, c, d, a, x[k + 2], S34, 0xC4AC5665);
        a = II(a, b, c, d, x[k + 0], S41, 0xF4292244);
        d = II(d, a, b, c, x[k + 7], S42, 0x432AFF97);
        c = II(c, d, a, b, x[k + 14], S43, 0xAB9423A7);
        b = II(b, c, d, a, x[k + 5], S44, 0xFC93A039);
        a = II(a, b, c, d, x[k + 12], S41, 0x655B59C3);
        d = II(d, a, b, c, x[k + 3], S42, 0x8F0CCC92);
        c = II(c, d, a, b, x[k + 10], S43, 0xFFEFF47D);
        b = II(b, c, d, a, x[k + 1], S44, 0x85845DD1);
        a = II(a, b, c, d, x[k + 8], S41, 0x6FA87E4F);
        d = II(d, a, b, c, x[k + 15], S42, 0xFE2CE6E0);
        c = II(c, d, a, b, x[k + 6], S43, 0xA3014314);
        b = II(b, c, d, a, x[k + 13], S44, 0x4E0811A1);
        a = II(a, b, c, d, x[k + 4], S41, 0xF7537E82);
        d = II(d, a, b, c, x[k + 11], S42, 0xBD3AF235);
        c = II(c, d, a, b, x[k + 2], S43, 0x2AD7D2BB);
        b = II(b, c, d, a, x[k + 9], S44, 0xEB86D391);
        a = AddUnsigned(a, AA);
        b = AddUnsigned(b, BB);
        c = AddUnsigned(c, CC);
        d = AddUnsigned(d, DD);
    }
    var temp = WordToHex(a) + WordToHex(b) + WordToHex(c) + WordToHex(d);
    return temp;
}

function RotateLeft(lValue, iShiftBits) {
    return (lValue << iShiftBits) | (lValue >>> (32 - iShiftBits));
}

function AddUnsigned(lX, lY) {
    var lX4, lY4, lX8, lY8, lResult;
    lX8 = (lX & 0x80000000);
    lY8 = (lY & 0x80000000);
    lX4 = (lX & 0x40000000);
    lY4 = (lY & 0x40000000);
    lResult = (lX & 0x3FFFFFFF) + (lY & 0x3FFFFFFF);
    if (lX4 & lY4) {
        return (lResult ^ 0x80000000 ^ lX8 ^ lY8);
    }
    if (lX4 | lY4) {
        if (lResult & 0x40000000) {
            return (lResult ^ 0xC0000000 ^ lX8 ^ lY8);
        } else {
            return (lResult ^ 0x40000000 ^ lX8 ^ lY8);
        }
    } else {
        return (lResult ^ lX8 ^ lY8);
    }
}

function F(x, y, z) {
    return (x & y) | ((~x) & z);
}

function G(x, y, z) {
    return (x & z) | (y & (~z));
}

function H(x, y, z) {
    return (x ^ y ^ z);
}

function I(x, y, z) {
    return (y ^ (x | (~z)));
}

function FF(a, b, c, d, x, s, ac) {
    a = AddUnsigned(a, AddUnsigned(AddUnsigned(F(b, c, d), x), ac));
    return AddUnsigned(RotateLeft(a, s), b);
}

function GG(a, b, c, d, x, s, ac) {
    a = AddUnsigned(a, AddUnsigned(AddUnsigned(G(b, c, d), x), ac));
    return AddUnsigned(RotateLeft(a, s), b);
}

function HH(a, b, c, d, x, s, ac) {
    a = AddUnsigned(a, AddUnsigned(AddUnsigned(H(b, c, d), x), ac));
    return AddUnsigned(RotateLeft(a, s), b);
}

function II(a, b, c, d, x, s, ac) {
    a = AddUnsigned(a, AddUnsigned(AddUnsigned(I(b, c, d), x), ac));
    return AddUnsigned(RotateLeft(a, s), b);
}

function ConvertToWordArray(string) {
    var lWordCount;
    var lMessageLength = string.length;
    var lNumberOfWords_temp1 = lMessageLength + 8;
    var lNumberOfWords_temp2 = (lNumberOfWords_temp1 - (lNumberOfWords_temp1 % 64)) / 64;
    var lNumberOfWords = (lNumberOfWords_temp2 + 1) * 16;
    var lWordArray = Array(lNumberOfWords - 1);
    var lBytePosition = 0;
    var lByteCount = 0;
    while (lByteCount < lMessageLength) {
        lWordCount = (lByteCount - (lByteCount % 4)) / 4;
        lBytePosition = (lByteCount % 4) * 8;
        lWordArray[lWordCount] = (lWordArray[lWordCount] | (string.charCodeAt(lByteCount) << lBytePosition));
        lByteCount++;
    }
    lWordCount = (lByteCount - (lByteCount % 4)) / 4;
    lBytePosition = (lByteCount % 4) * 8;
    lWordArray[lWordCount] = lWordArray[lWordCount] | (0x80 << lBytePosition);
    lWordArray[lNumberOfWords - 2] = lMessageLength << 3;
    lWordArray[lNumberOfWords - 1] = lMessageLength >>> 29;
    return lWordArray;
}

function WordToHex(lValue) {
    var WordToHexValue = "",
        WordToHexValue_temp = "",
        lByte, lCount;
    for (lCount = 0; lCount <= 3; lCount++) {
        lByte = (lValue >>> (lCount * 8)) & 255;
        WordToHexValue_temp = "0" + lByte.toString(16);
        WordToHexValue = WordToHexValue + WordToHexValue_temp.substr(WordToHexValue_temp.length - 2, 2);
    }
    return WordToHexValue;
}

function Utf8Encode(string) {
    var utftext = "";
    for (var n = 0; n < string.length; n++) {
        var c = string.charCodeAt(n);
        if (c < 128) {
            utftext += String.fromCharCode(c);
        } else if ((c > 127) && (c < 2048)) {
            utftext += String.fromCharCode((c >> 6) | 192);
            utftext += String.fromCharCode((c & 63) | 128);
        } else {
            utftext += String.fromCharCode((c >> 12) | 224);
            utftext += String.fromCharCode(((c >> 6) & 63) | 128);
            utftext += String.fromCharCode((c & 63) | 128);
        }
    }
    return utftext;
}

function selectDate(type, dates, cb) {
    if (!type) {
        form_tip('选择需要打开的时间类型');
        return false;
    }
    //移除事件监听
    api.removeEventListener({
        name: 'selectDateBackEvent'
    });
    //添加事件监听
    api.addEventListener({
        name: 'selectDateBackEvent'
    }, function(ret, err) {
        if (ret && ret.value && ret.value.dateDate) {
            cb && cb(ret.value.dateDate);
        } else {
            cb && cb([]);
        }
        //移除事件监听
        api.removeEventListener({
            name: 'selectDateBackEvent'
        });
    });


    api.openFrame({
        name: 'check_work_date',
        url: './check_date_frame.html',
        bgColor: 'rgba(100,100,100,0.5)',
        rect: {
            x: 0,
            y: 0,
            w: 'auto',
            h: 'auto'
        },
        pageParam: {
            type: type,
            dates: dates
        },
        bounces: false,
        animation: {
            type: "movein", //动画类型（详见动画类型常量）
            subType: "from_bottom", //动画子类型（详见动画子类型常量）
            duration: 200 //动画过渡时间，默认300毫秒
        }
    })
}


// 特殊权限动态判断：
function hasAndReqPermission(perm, perm_name, callback) {
    var perms = 'camera' == perm ? ['camera', 'photos'] : [perm];
    var rets = api.hasPermission({
        list: perms
    });
    //判断，如果有权限直接调用回调，否则触发权限提示；
    var ok_nums = 0;
    for (var i = 0; i < rets.length; i++) {
        if (rets[i].granted) {
            ok_nums++;
        }
    }
    if (ok_nums == rets.length) {
        //直接调用回调：
        callback();
        return;
    }

    //提示权限：
    api.requestPermission({
        list: perms,
        code: 100001
    }, function(ret, err) {
        var list = ret.list;
        for (var i = 0; i < rets.length; i++) {
            if (!list[i].granted) {
                show_alert('请打开应用【' + perm_name + '】访问权限后使用当前功能！');
                return;
            }
        }
        //调用回调：
        callback(ret);
    });
}
